using System;
using System.Drawing;
using System.Threading;
using System.Windows.Forms;
using DAMacTypesLib;
using DATypesLib;

namespace DAMac {
    public class DAMacros : DAMacCore {
        public DAWalkerProg.DAWalker_form MainF;

        public DAMacros(IntPtr mainHandle) : this(mainHandle, null, null, null) { }
        public DAMacros(IntPtr mainHandle, NotifyIcon sysTray, Icon sysNormal, Icon sysRun)
            : base(mainHandle, sysTray, sysNormal, sysRun) {
            AddHotkey(Keys.F1, WindowModifiers.MOD_ALT | WindowModifiers.MOD_CONTROL | WindowModifiers.MOD_SHIFT, FConDionMacro, true);
            AddHotkey(Keys.F2, WindowModifiers.MOD_ALT | WindowModifiers.MOD_CONTROL | WindowModifiers.MOD_SHIFT, FConHideMacro, true);
            AddHotkey(Keys.F3, WindowModifiers.MOD_ALT | WindowModifiers.MOD_CONTROL | WindowModifiers.MOD_SHIFT, FHideOffMacro, true);
        }

        public void FConDionMacro(MacInfo runInfo) {
            byte[] DionKey = GetDASlot(DAPane.d, "Draco Stance", false, runInfo, DASlotSearchType.StartsWith);
            if(DionKey.Length == 0) DionKey = GetDASlot(DAPane.d, "mor dion", false, runInfo, DASlotSearchType.StartsWith);
            if(DionKey.Length == 0) DionKey = GetDASlot(DAPane.d, "Dion", false, runInfo, DASlotSearchType.StartsWith);
            if(DionKey.Length == 0) DionKey = GetDASlot(DAPane.d, "dion", false, runInfo, DASlotSearchType.StartsWith);
            if(DionKey.Length == 0) DionKey = GetDASlot(DAPane.d, "Wings of", false, runInfo, DASlotSearchType.StartsWith);
            if(DionKey.Length == 0) DionKey = GetDASlot(DAPane.d, "Iron Skin", false, runInfo, DASlotSearchType.StartsWith);
            if(DionKey.Length == 0) {
                HKRunning[runInfo] = false;
                MessageBox.Show("Couldn't find Dion Spell... Make sure you have it.");
                return;
            }
            ushort DionCost = 1000;
            while(HKRunning[runInfo]) {
                while(!IsDASpellIconOn(DASpell.Dion, runInfo) && HKRunning[runInfo]) {
                    if(GetDAStatNumber(DAStat.CurMP, runInfo) < DionCost) break;
                    UseDAAttack(DionKey[0], DAPane.d, false, runInfo);
                    Thread.Sleep(350);
                }
                Thread.Sleep(50);
            }
        }


        public void FConHideMacro(MacInfo runInfo) {
            byte[] HideKey = GetDASlot(DAPane.d, "Hide", false, runInfo, DASlotSearchType.StartsWith);
            if(HideKey.Length == 0) HideKey = GetDASlot(DAPane.d, "White Bat", false, runInfo, DASlotSearchType.StartsWith);
            if(HideKey.Length == 0) {
                HKRunning[runInfo] = false;
                MessageBox.Show("Couldn't find Hide DASpell... Make sure you have it.");
                return;
            }
            ushort DionCost = 200;

            while(HKRunning[runInfo]) {
                while(!IsDASpellIconOn(DASpell.Hide, runInfo) && HKRunning[runInfo]) {
                    if(GetDAStatNumber(DAStat.CurMP, runInfo) < DionCost) break;
                    UseDAAttack(HideKey[0], DAPane.d, false, runInfo);
                    Thread.Sleep(350);
                }
                Thread.Sleep(50);
            }
        }

        public void FHideOffMacro(MacInfo runInfo) {
            int option = MainF.mainWalker.optionMain;
            byte otherKey = (byte)MainF.mainWalker.spellLoc;

            while(HKRunning[runInfo]) {
                if(!IsDASpellIconOn(DASpell.Hide, runInfo) && HKRunning[runInfo]) {
                    switch(option) {
                        case 2:
                            //log if hide runs
                            SendKeyPM(Keys.Q, Keys.None, runInfo.Handle);
                            SendKeyPM(Keys.X, Keys.None, runInfo.Handle);
                            break;
                        case 3:
                            //scroll if hide runs
                            UseDAAttack(otherKey, DAPane.a, false, runInfo);
                            break;
                        case 4:
                            //dach if hide runs
                            byte[] DachKey = GetDASlot(DAPane.d, "dachaidh", false, runInfo, DASlotSearchType.StartsWith);
                            if(DachKey.Length == 0) {
                                HKRunning[runInfo] = false;
                                MessageBox.Show("Couln't Find Dach DASpell... Make sure you have it");
                                return;
                            }
                            UseDAAttack(DachKey[0], DAPane.d, false, runInfo);
                            Thread.Sleep(1250);
                            break;
                    }
                    HKRunning[runInfo] = false;
                    MainF.stopWalkerForce();
                }
                Thread.Sleep(50);
            }
        }
    }
}