using System;
using System.Windows.Forms;

namespace DAWalkerProg {
    public partial class DAWalkerSetting_form : Form {
        DAWalker_form mainParent;
        bool allow = false;

        public DAWalkerSetting_form(DAWalker_form handel) {
            InitializeComponent();

            mainParent = handel;

            textBox_delay.Text = mainParent.mainWalker.MainMover.delay.ToString();
            textBox_wall.Text = mainParent.mainWalker.MainMover.WallChecks.ToString();
            label2.Text = "Version " + Application.ProductVersion;
            comboBox_macro.SelectedIndex = 0;
        }

        private void button_okay_Click(object sender, EventArgs e) {
            try {
                int.Parse(textBox_delay.Text);
                int.Parse(textBox_wall.Text);
            } catch {
                MessageBox.Show("Please enter only numbers in the Delay and Wall Checks.");
                return;
            }
            mainParent.mainWalker.MainMover.delay = int.Parse(textBox_delay.Text);
            mainParent.mainWalker.MainMover.WallChecks = int.Parse(textBox_wall.Text);

            switch(comboBox_macro.SelectedIndex) {
                case 0:
                    break;
                case 1:
                    //mainParent.mainWalker.MainSpecial.RemoveHotkey(mainParent.mainWalker.MainSpecial.hkAtomNames[3]);
                    mainParent.mainWalker.MainSpecial.RemoveHotkey(mainParent.currHotKeyAtom);
                    mainParent.mainWalker.MainSpecial.AddHotkey(Keys.Oemtilde, 0, mainParent.mainWalker.MainSpecial.FConDionMacro, true);
                    break;
                case 2:
                    //mainParent.mainWalker.MainSpecial.RemoveHotkey(mainParent.mainWalker.MainSpecial.hkAtomNames[3]);
                    mainParent.mainWalker.MainSpecial.RemoveHotkey(mainParent.currHotKeyAtom);
                    mainParent.mainWalker.MainSpecial.AddHotkey(Keys.Home, 0, mainParent.mainWalker.MainSpecial.FConDionMacro, true);
                    break;
                case 3:
                    //mainParent.mainWalker.MainSpecial.RemoveHotkey(mainParent.mainWalker.MainSpecial.hkAtomNames[3]);
                    mainParent.mainWalker.MainSpecial.RemoveHotkey(mainParent.currHotKeyAtom);
                    mainParent.mainWalker.MainSpecial.AddHotkey(Keys.Insert, 0, mainParent.mainWalker.MainSpecial.FConDionMacro, true);
                    break;
                case 4:
                    //mainParent.mainWalker.MainSpecial.RemoveHotkey(mainParent.mainWalker.MainSpecial.hkAtomNames[3]);
                    mainParent.mainWalker.MainSpecial.RemoveHotkey(mainParent.currHotKeyAtom);
                    mainParent.mainWalker.MainSpecial.AddHotkey(Keys.F1, 0, mainParent.mainWalker.MainSpecial.FConDionMacro, true);
                    break;
            }
            this.Close();
        }

        private void checkBox_safe_CheckedChanged(object sender, EventArgs e) {
            if(allow) return;
            else if(!checkBox_safe.Checked && !checkBox_fast.Checked && !checkBox_sfast.Checked) checkBox_safe.Checked = true;
            else {
                checkBox_fast.Checked = false;
                checkBox_sfast.Checked = false;

                textBox_delay.Text = "510";
                textBox_wall.Text = "2";
            }
        }

        private void checkBox_fast_CheckedChanged(object sender, EventArgs e) {
            if(allow) return;
            else if(!checkBox_safe.Checked && !checkBox_fast.Checked && !checkBox_sfast.Checked) checkBox_fast.Checked = true;
            else {
                checkBox_safe.Checked = false;
                checkBox_sfast.Checked = false;

                textBox_delay.Text = "460";
                textBox_wall.Text = "2";
            }
        }


        private void checkBox_sfast_CheckedChanged(object sender, EventArgs e) {
            if(allow) return;
            else if(!checkBox_safe.Checked && !checkBox_fast.Checked && !checkBox_sfast.Checked) checkBox_sfast.Checked = true;
            else {
                checkBox_safe.Checked = false;
                checkBox_fast.Checked = false;

                textBox_delay.Text = "100";
                textBox_wall.Text = "10";
            }
        }

        private void textBox_delay_TextChanged(object sender, EventArgs e) {
            allow = true;
            checkBox_fast.Checked = false;
            checkBox_safe.Checked = false;
            checkBox_sfast.Checked = false;
            if(textBox_delay.Text == "510" && textBox_wall.Text == "2") checkBox_safe.Checked = true;
            if(textBox_delay.Text == "460" && textBox_wall.Text == "2") checkBox_fast.Checked = true;
            if(textBox_delay.Text == "100" && textBox_wall.Text == "10") checkBox_sfast.Checked = true;
            allow = false;
        }

        private void textBox_wall_TextChanged(object sender, EventArgs e) {
            allow = true;
            checkBox_fast.Checked = false;
            checkBox_safe.Checked = false;
            checkBox_sfast.Checked = false;
            if(textBox_delay.Text == "510" && textBox_wall.Text == "2") checkBox_safe.Checked = true;
            if(textBox_delay.Text == "460" && textBox_wall.Text == "2") checkBox_fast.Checked = true;
            if(textBox_delay.Text == "100" && textBox_wall.Text == "10") checkBox_sfast.Checked = true;
            allow = false;
        }

        private void DAWalkerSetting_form_FormClosed(object sender, FormClosedEventArgs e) {
            mainParent.linkLabel_settings.Enabled = true;
        }
    }
}