using System;
using System.Collections.Generic;
using System.Windows.Forms;


namespace DAWalkerProg {
    public partial class DAWalker_form : Form {
        //WinUser.h Definitions
        private const ushort WM_HOTKEY = 0x0312;

        public bool macOn = false, forcedStop = false;
        public MyToolTipLib.MyToolTip Tip = new MyToolTipLib.MyToolTip();
        public DAWalkerStart mainWalker;
        public List<string> otherList = new List<string>();
        public ushort currHotKeyAtom;

        public DAWalker_form() {
            InitializeComponent();
            this.Text = "DAWalker v" + Application.ProductVersion;

            if(!System.IO.File.Exists("DAData.xml")) { MessageBox.Show("DAData.xml file not found: Download the file from www.da-wizard.com."); Environment.Exit(0); }

            mainWalker = new DAWalkerStart(this);
            mainWalker.initilizeMap();
            currHotKeyAtom = mainWalker.MainSpecial.AddHotkey(Keys.Oemtilde, 0, new DAMacTypesLib.RunMacro(mainWalker.MainSpecial.FConDionMacro), false).Value;
        }

        protected override void WndProc(ref Message m) {
            if(m.Msg == WM_HOTKEY && mainWalker.MainSpecial.GetMacNumber((ushort)m.WParam).HasValue) {
                if(!macOn) startWalker();
                else stopWalkerForce();
            } else base.WndProc(ref m);
        }

        private void radioButton_blossom_Click(object sender, EventArgs e) {
            this.listBox_finish.Items.Clear();
            this.select_finish.Enabled = false;
            this.select_finish2.Enabled = false;
            this.button_large.Visible = false;

            this.listBox_finish.Items.AddRange(new object[] {
            "Veltain Mines"});
            this.listBox_finish.SelectionMode = System.Windows.Forms.SelectionMode.None;

            this.groupBox_dion.Visible = false;
            this.groupBox_hide.Visible = false;
            this.groupBox_options.Visible = true;
        }

        private void radioButton_andor_Click(object sender, EventArgs e) {
            this.listBox_finish.Items.Clear();
            this.select_finish.Enabled = true;
            this.select_finish2.Enabled = true;
            this.button_large.Visible = false;

            this.listBox_finish.Items.AddRange(new object[] {
            "Andor Lobby Middle",
            "Andor 80 - Right Hand Route"});
            this.listBox_finish.SelectionMode = System.Windows.Forms.SelectionMode.One;
            this.listBox_finish.SelectedIndex = 0;

            this.groupBox_hide.Text = "Options - Andor";
            this.checkBox_alog.Checked = false;

            unEnableAndor();
            this.checkBox_adach.Checked = false;
            this.checkBox_ahide.Checked = false;
            this.checkBox_ascroll.Checked = false;

            this.groupBox_dion.Visible = false;
            this.groupBox_hide.Visible = true;
            this.groupBox_options.Visible = false;
        }

        private void radioButton_shinewood_Click(object sender, EventArgs e) {
            this.listBox_finish.Items.Clear();
            this.select_finish.Enabled = true;
            this.select_finish2.Enabled = true;
            this.button_large.Visible = false;

            this.label_other.Visible = false;
            this.textBox_other.Visible = false;

            this.listBox_finish.Items.AddRange(new object[] {
            "Shinewood Forest 22",
            "Shinewood Hut in 30"});
            this.listBox_finish.SelectionMode = System.Windows.Forms.SelectionMode.One;
            this.listBox_finish.SelectedIndex = 0;

            this.groupBox_hide.Visible = false;
            this.groupBox_options.Visible = false;
            this.groupBox_dion.Visible = true;
        }

        private void radioButton_giragan_Click(object sender, EventArgs e) {
            this.listBox_finish.Items.Clear();
            this.select_finish.Enabled = true;
            this.select_finish2.Enabled = true;
            this.button_large.Visible = false;

            this.listBox_finish.Items.AddRange(new object[] {
            "Mount Giragan 3",
            "Mount Giragan 10",
            "Mount Giragan 13"});
            this.listBox_finish.SelectionMode = System.Windows.Forms.SelectionMode.One;
            this.listBox_finish.SelectedIndex = 1;

            this.groupBox_dion.Visible = false;
            this.groupBox_hide.Visible = false;
            this.groupBox_options.Visible = true;
        }

        private void radioButton_chaos_Click(object sender, EventArgs e) {
            this.listBox_finish.Items.Clear();
            this.select_finish.Enabled = true;
            this.select_finish2.Enabled = true;
            this.button_large.Visible = false;

            this.listBox_finish.Items.AddRange(new object[] {
            "Chaos Enterance",
            "Chaos 12",
            "Chaos 34 + Portal Maze"});
            this.listBox_finish.SelectionMode = System.Windows.Forms.SelectionMode.One;
            this.listBox_finish.SelectedIndex = 0;

            this.groupBox_hide.Text = "Options - Chaos";
            this.checkBox_ahide.Checked = false;

            this.checkBox_adach.Checked = false;
            this.checkBox_alog.Checked = false;
            this.checkBox_ascroll.Checked = false;

            unEnableAndor();

            this.groupBox_dion.Visible = false;
            this.groupBox_hide.Visible = true;
            this.groupBox_options.Visible = false;
        }

        private void radioButton_cthonic_Click(object sender, EventArgs e) {
            this.listBox_finish.Items.Clear();
            this.select_finish.Enabled = true;
            this.select_finish2.Enabled = true;
            this.button_large.Visible = false;

            this.label_other.Visible = false;
            this.textBox_other.Visible = false;

            this.listBox_finish.Items.AddRange(new object[] {
            "Cthonic Remains 1",
            "Cthonic Remains 10",
            "Cthonic Remains 30"});
            this.listBox_finish.SelectionMode = System.Windows.Forms.SelectionMode.One;
            this.listBox_finish.SelectedIndex = 2;

            this.groupBox_dion.Visible = true;
            this.groupBox_hide.Visible = false;
            this.groupBox_options.Visible = false;
        }

        private void radioButton_crypt_Click(object sender, EventArgs e) {
            this.listBox_finish.Items.Clear();
            this.select_finish.Enabled = false;
            this.select_finish2.Enabled = false;
            this.button_large.Visible = false;

            this.label_other.Visible = false;
            this.textBox_other.Visible = false;

            this.listBox_finish.Items.AddRange(new object[] {
            "Mileth Crypt 31"});
            this.listBox_finish.SelectionMode = System.Windows.Forms.SelectionMode.None;

            this.groupBox_dion.Visible = true;
            this.groupBox_hide.Visible = false;
            this.groupBox_options.Visible = false;
        }

        private void radioButton_suomi_Click(object sender, EventArgs e) {
            this.listBox_finish.Items.Clear();
            this.select_finish.Enabled = false;
            this.select_finish2.Enabled = false;
            this.button_large.Visible = false;

            this.listBox_finish.Items.AddRange(new object[] {
            "Suomi Middle Map"});
            this.listBox_finish.SelectionMode = System.Windows.Forms.SelectionMode.None;

            this.groupBox_dion.Visible = false;
            this.groupBox_hide.Visible = false;
            this.groupBox_options.Visible = true;
        }


        private void radioButton_nobis_Click(object sender, EventArgs e) {
            this.listBox_finish.Items.Clear();
            this.select_finish.Enabled = false;
            this.select_finish2.Enabled = false;
            this.button_large.Visible = false;

            this.label_other.Visible = false;
            this.textBox_other.Visible = false;

            this.listBox_finish.Items.AddRange(new object[] {
            "Nobis Village"});
            this.listBox_finish.SelectionMode = System.Windows.Forms.SelectionMode.None;

            this.groupBox_dion.Visible = true;
            this.groupBox_hide.Visible = false;
            this.groupBox_options.Visible = false;
        }

        private void radioButton_canals_Click(object sender, EventArgs e) {
            this.listBox_finish.Items.Clear();
            this.select_finish.Enabled = true;
            this.select_finish2.Enabled = true;
            this.button_large.Visible = false;

            this.listBox_finish.Items.AddRange(new object[] {
            "Loures Canals Enterance",
            "Key 1 - Skrull Enterance",
            "Key 2 - Blob Enterance"});
            this.listBox_finish.SelectionMode = System.Windows.Forms.SelectionMode.One;
            this.listBox_finish.SelectedIndex = 0;

            this.groupBox_dion.Visible = false;
            this.groupBox_hide.Visible = false;
            this.groupBox_options.Visible = true;
        }

        private void radBtn_spirit_Click(object sender, EventArgs e) {
            this.listBox_finish.Items.Clear();
            this.select_finish.Enabled = true;
            this.select_finish2.Enabled = true;
            this.button_large.Visible = false;

            this.listBox_finish.Items.AddRange(new object[] {
            "Earth Spirit",
            "Fire Spirit",
            "Water Spirit"});
            this.listBox_finish.SelectionMode = System.Windows.Forms.SelectionMode.One;
            this.listBox_finish.SelectedIndex = 0;

            this.groupBox_dion.Visible = false;
            this.groupBox_hide.Visible = false;
            this.groupBox_options.Visible = true;
        }

        private void radioButton_other_Click(object sender, EventArgs e) {
            this.listBox_finish.Items.Clear();
            this.select_finish.Enabled = true;
            this.select_finish2.Enabled = true;
            this.button_large.Visible = true;

            this.label_other.Visible = true;
            this.textBox_other.Visible = true;

            foreach(string A in otherList) this.listBox_finish.Items.Add(A);
            this.listBox_finish.SelectionMode = System.Windows.Forms.SelectionMode.One;

            this.groupBox_dion.Visible = true;
            this.groupBox_hide.Visible = false;
            this.groupBox_options.Visible = false;
        }

        private void checkBox_dion_CheckedChanged(object sender, EventArgs e) {
            if(checkBox_dion.Checked == true) this.checkBox_hide.Checked = false;
        }

        private void checkBox_hide_CheckedChanged(object sender, EventArgs e) {
            if(checkBox_hide.Checked == true) this.checkBox_dion.Checked = false;
        }

        private void unEnableAndor() {
            this.label_akey.Enabled = false;
            this.label_aitem.Enabled = false;
            this.textBox_aitem.Enabled = false;
        }

        private void checkBox_ahide_Click(object sender, EventArgs e) {
            this.checkBox_adach.Checked = false;
            this.checkBox_alog.Checked = false;
            this.checkBox_ascroll.Checked = false;

            unEnableAndor();
        }

        private void checkBox_alog_Click(object sender, EventArgs e) {
            this.checkBox_adach.Checked = false;
            this.checkBox_ahide.Checked = false;
            this.checkBox_ascroll.Checked = false;

            unEnableAndor();
        }

        private void checkBox_ascroll_Click(object sender, EventArgs e) {
            this.checkBox_adach.Checked = false;
            this.checkBox_ahide.Checked = false;
            this.checkBox_alog.Checked = false;

            if(this.checkBox_ascroll.Checked == true) {
                unEnableAndor();
                this.label_aitem.Enabled = true;
                this.label_akey.Enabled = true;
                this.textBox_aitem.Enabled = true;
            } else unEnableAndor();
        }

        private void checkBox_adach_Click(object sender, EventArgs e) {
            this.checkBox_ahide.Checked = false;
            this.checkBox_alog.Checked = false;
            this.checkBox_ascroll.Checked = false;

            unEnableAndor();
        }

        private void startWalker() {
            int place = 0, finish = 0, option = 0, item = 0;

            if(radioButton_blossom.Checked) {
                place = 1;
                finish = 0;
                option = 0;
                item = 0;
            }
            if(radioButton_andor.Checked && listBox_finish.SelectedIndex == 0) {
                place = 2;
                finish = 0;

                if(checkBox_ahide.Checked) option = 1;
                if(checkBox_alog.Checked) option = 2;
                if(checkBox_ascroll.Checked) option = 3;
                if(checkBox_adach.Checked) option = 4;

                int.TryParse(textBox_aitem.Text, out item);
                if(option == 3 && item == 0) {
                    MessageBox.Show("Enter Scroll Location");
                    return;
                }
            }
            if(radioButton_andor.Checked && listBox_finish.SelectedIndex == 1) {
                place = 3;
                finish = 0;

                if(checkBox_ahide.Checked) option = 1;
                if(checkBox_alog.Checked) option = 2;
                if(checkBox_ascroll.Checked) option = 3;
                if(checkBox_adach.Checked) option = 4;

                int.TryParse(textBox_aitem.Text, out item);
                if(option == 3 && item == 0) {
                    MessageBox.Show("Enter Scroll Location");
                    return;
                }
            }
            if(radioButton_shinewood.Checked) {
                place = 4;
                finish = listBox_finish.SelectedIndex + 1;

                if(checkBox_dion.Checked) option = 5;
                if(checkBox_hide.Checked) option = 1;

                item = 0;
            }
            if(radioButton_giragan.Checked) {
                place = 5;
                finish = listBox_finish.SelectedIndex + 1;
                option = 0;
                item = 0;
            }
            if(radioButton_chaos.Checked) {
                place = 6;
                finish = listBox_finish.SelectedIndex + 1;

                if(checkBox_ahide.Checked) option = 1;
                if(checkBox_alog.Checked) option = 2;
                if(checkBox_ascroll.Checked) option = 3;
                if(checkBox_adach.Checked) option = 4;

                int.TryParse(textBox_aitem.Text, out item);
                if(option == 3 && item == 0) {
                    MessageBox.Show("Enter Scroll Location");
                    return;
                }
            }
            if(radioButton_cthonic.Checked) {
                place = 7;
                finish = listBox_finish.SelectedIndex + 1;

                if(checkBox_dion.Checked) option = 5;
                if(checkBox_hide.Checked) option = 1;

                item = 0;
            }
            if(radioButton_crypt.Checked) {
                place = 8;
                finish = 0;

                if(checkBox_dion.Checked) option = 5;
                if(checkBox_hide.Checked) option = 1;

                item = 0;
            }
            if(radioButton_suomi.Checked) {
                place = 9;
                finish = 0;
                option = 0;
                item = 0;
            }
            if(radioButton_nobis.Checked) {
                place = 10;
                finish = 0;

                if(checkBox_dion.Checked) option = 5;
                if(checkBox_hide.Checked) option = 1;

                item = 0;
            }
            if(radioButton_canals.Checked) {
                place = 11;
                finish = listBox_finish.SelectedIndex + 1;
                option = 0;
                item = 0;
            }
            if(radioButton_spirits.Checked) {
                place = 12;
                finish = listBox_finish.SelectedIndex + 1;
                option = 0;
                item = 0;
            }
            if(radioButton_other.Checked) {
                if(checkBox_dion.Checked) option = 5;
                if(checkBox_hide.Checked) option = 1;


                if(!int.TryParse(textBox_other.Text, out place)) place = -1;
                if(place == -1) {
                    MessageBox.Show("Enter Destination Map # Please");
                    return;
                }
                finish = 0;
                item = 0;
            }

            if(!mainWalker.MainMover.StartProcessCheck()) return;

            Tip.ShowToolTip("DAWalker is Running", mainWalker.MainMover.DarkageshWnd);
            macOn = true;
            forcedStop = false;
            if(checkBox_louresaite.Checked) {
                if(mainWalker.startAite() == 1) {
                    macOn = false;
                    Tip.ShowToolTip("", mainWalker.MainMover.DarkageshWnd);
                } else while(mainWalker.MainMoverT.IsAlive) Application.DoEvents();
            }
            if(!forcedStop) {
                Tip.ShowToolTip("DAWalker is Running", mainWalker.MainMover.DarkageshWnd);
                macOn = true;
                if(mainWalker.startMac(place, finish, option, item) == 1) {
                    macOn = false;
                    Tip.ShowToolTip("", mainWalker.MainMover.DarkageshWnd);
                }
            }
        }

        public void stopWalkerForce() {
            macOn = false;
            forcedStop = true;
            if(mainWalker.MainSpecial != null) mainWalker.MainSpecial.HKRunning.SetToFalse();
            if(mainWalker.MainMoverT.IsAlive) mainWalker.stopMac();
            Tip.ShowToolTip("", mainWalker.MainMover.DarkageshWnd);
        }

        public void stopWalker() {
            macOn = false;
            if(mainWalker.MainSpecial != null) mainWalker.MainSpecial.HKRunning.SetToFalse();
            Tip.ShowToolTip("", mainWalker.MainMover.DarkageshWnd);
        }

        private void checkBox_useCaravan_CheckedChanged(object sender, EventArgs e) {
            if(checkBox_useCaravan.Checked == true) mainWalker.addCaravan();
            else if(checkBox_useCaravan.Checked == false) mainWalker.removeCaravan();
        }

        private void linkLabel_settings_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e) {
            DAWalkerSetting_form settingsBox = new DAWalkerSetting_form(this);
            settingsBox.Show();
            linkLabel_settings.Enabled = false;
        }

        private void pictureBox_donate_Click(object sender, EventArgs e) {
            System.Diagnostics.Process.Start("https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=biothean%40hotmail%2ecom&item_name=DA%2dWizard%2ecom%20Donation&no_shipping=1&return=http%3a%2f%2fwww%2eda%2dwizard%2ecom%2fdonate_confirm%2ehtml&cn=Enter%20Character%20Name%3a&tax=0&currency_code=USD&bn=PP%2dDonationsBF&charset=UTF%2d8");
        }

        private void linkLabel_hide_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e) {
            groupBox_donate.Hide();
            Height = 361;
        }

        private void listBox_finish_SelectedIndexChanged(object sender, EventArgs e) {
            if(radioButton_other.Checked == true) {
                string[] temp = listBox_finish.SelectedItem.ToString().Split(' ');
                textBox_other.Text = temp[temp.Length - 1];
            }
        }

        private void DAWalker_form_FormClosing(object sender, FormClosingEventArgs e) {
            if(mainWalker != null && mainWalker.MainMoverT != null && mainWalker.MainMoverT.IsAlive) mainWalker.MainMoverT.Abort();
        }

        private void button_large_Click(object sender, EventArgs e) {
            otherForm otherBox = new otherForm(this);
            otherBox.Show();
            button_large.Enabled = false;
        }
    }
}