using System;
using System.Collections;
using System.Globalization;
using System.IO;
using System.Runtime.InteropServices;
using System.Threading;
using System.Windows.Forms;
using System.Xml.Linq;

namespace DAMover {
    /// <summary>
    /// Summary description for Searcher.
    /// </summary>
    public class Mover {
        ///	<-------------------------------------------------->
        ///		BOOL PostMessage(
        ///		    HWND hWnd,
        ///			UINT Msg,		((IE "WM_KEYDOWN" "WM_CHAR"))
        ///			WPARAM wParam,	((Depends on Msg))
        ///			LPARAM lParam	((Depends on Msg))
        ///			);
        ///	<-------------------------------------------------->
        [DllImport("user32.dll")]
        public static extern bool PostMessage(IntPtr hWnd, int Msg, int wParam, uint lParam);

        public MyMemoryReadSearchLib.MyMemoryReadSearch pReader = new MyMemoryReadSearchLib.MyMemoryReadSearch();
        private byte[] memory = null;

        //Change to Use DAMac's GetPointer In Future
        public IntPtr DarkageshWnd = IntPtr.Zero;
        public MyDAMapLib.MyDAMap myDAMap = new MyDAMapLib.MyDAMap();

        private int InfoBasePtr = Int32.Parse(XElement.Load("DAData.xml").Element("Pointers").Element("MapNum").Value, NumberStyles.HexNumber, CultureInfo.InvariantCulture);
        private int YAddress = 0;
        private int YAddressOff = Int32.Parse(XElement.Load("DAData.xml").Element("Pointers").Element("Coords").Attribute("o1").Value, NumberStyles.HexNumber, CultureInfo.InvariantCulture);
        private int XAddress = 0;
        private int XAddressOff = Int32.Parse(XElement.Load("DAData.xml").Element("Pointers").Element("Coords").Attribute("o1").Value, NumberStyles.HexNumber, CultureInfo.InvariantCulture) + Int32.Parse(XElement.Load("DAData.xml").Element("Pointers").Element("Coords").Attribute("size").Value, NumberStyles.HexNumber, CultureInfo.InvariantCulture);
        private int MapNumAddress = 0;
        private int MapNumAddressOff = Int32.Parse(XElement.Load("DAData.xml").Element("Pointers").Element("MapNum").Attribute("o1").Value, NumberStyles.HexNumber, CultureInfo.InvariantCulture);

        public int X, Y, MaxX, MaxY, MapNum, MapNumStart = 0;
        public int delay = 510;
        public int WallChecks = 2;
        private string PrevDirection = "";
        public bool Running = false;
        public char[,] mainMap;
        private DAWalkerProg.DAWalkerStart MainParent;

        int destinationMap = 0, destinX = 0, destinY = 0;
        bool completeDone = false, doorFail = false;

        public Mover(DAWalkerProg.DAWalkerStart MainF) {
            //
            // TODO: Add constructor logic here
            //
            MainParent = MainF;
            MakeMainMap(200, 200);
        }

        public void startMovement(Object pathO) {
            int[] path = (int[])pathO;
            int[] exitLoc;
            int[] mouseLoc = new int[0];

            int axisx, axisy, i = 0, previousMap = -1, temp = -1;
            bool lastRun = false, portalRun = false, knownMap = false;
            while(!lastRun || portalRun) {
                int m = 0;
                while(MapNum == previousMap && m < 15 && !((MapNum >= 2908 && MapNum <= 2916))) {
                    UpdateValues();
                    Thread.Sleep(50);
                    m++;
                }

                if(previousMap == MapNum && !((MapNum >= 2908 && MapNum <= 2916) || MapNum == 4335)) {
                    MainParent.MainSpecial.SendKeyPM(Keys.F5, DarkageshWnd, DAMacTypesLib.DAMacKeyOps.SK_REAL);
                    Thread.Sleep(1500);
                    UpdateValues();
                }

                i = 0;
                while(i < path.Length && MapNum != path[i]) {
                    i++;
                    if(i == path.Length) {
                        if(!MainParent.mapNodes.ContainsKey(MapNum) || MainParent.mapNodes[MapNum].mapAxis == null || MainParent.mapNodes[MapNum].getExitLoc(previousMap) != null) {
                            MainParent.formParent.stopWalker();
                            MessageBox.Show("Current Map is not apart of the Path Variable or World Map.  Restart the Walker.");
                            return;
                        } else knownMap = true;
                    }
                }
                if(!knownMap) {
                    if(i == (path.Length - 1)) {
                        if(MapNum == 4335) portalRun = true;
                        if(MapNum == 4335 && X == 8 && Y == 93) {
                            portalRun = false;
                            break;
                        }
                        lastRun = true;

                        exitLoc = MainParent.mapNodes[path[i]].getExitLoc(-1);
                    } else exitLoc = MainParent.mapNodes[path[i]].getExitLoc(path[i + 1]);
                } else {
                    exitLoc = MainParent.mapNodes[MapNum].getExitLoc(previousMap);
                    i = 0;
                    temp = path[i];
                    path[i] = MapNum;
                }

                //Loads the Map
                if(MainParent.mapNodes[path[i]].loadMap == 1) MakeMainMap(200, 200);
                else {
                    try {
                        int counter = 0;
                        while(!File.Exists(MainParent.pathDA + "lod" + path[i].ToString() + ".map") && counter <= 25) {
                            counter++;
                            Thread.Sleep(200);
                        }
                        if(counter == 26) {
                            MainParent.formParent.stopWalker();
                            MessageBox.Show("Couldn't Open Map File: " + MainParent.pathDA + "lod" + path[i].ToString() + ".map");
                            return;
                        }
                    } catch(Exception e) {
                        MainParent.formParent.stopWalker();
                        MessageBox.Show("Couldn't Open Map File: " + e.Message);
                        return;
                    }

                    if(MainParent.mapNodes[path[i]].mapAxis[0] != -1) {
                        axisx = MainParent.mapNodes[path[i]].mapAxis[0];
                        axisy = MainParent.mapNodes[path[i]].mapAxis[1];
                    } else {
                        FileInfo TempInfo = new FileInfo(MainParent.pathDA + "lod" + path[i].ToString() + ".map");
                        if(!TempInfo.Exists) {
                            Thread.Sleep(2000);
                            if(!(TempInfo = new FileInfo(MainParent.pathDA + "lod" + path[i].ToString() + ".map")).Exists) {
                                MainParent.formParent.stopWalker();
                                MessageBox.Show("Load Map Failed - Couldn't Find the Map '" + MainParent.pathDA + "lod" + path[i].ToString() + ".map'");
                                return;
                            }
                        }

                        long NumOfBlocks = TempInfo.Length / 6;
                        double SQRTRootAsFloat = Math.Sqrt(NumOfBlocks);
                        int SQRTRootAsInt = (int)Math.Round(SQRTRootAsFloat);

                        if(SQRTRootAsFloat != SQRTRootAsInt) {
                            MainParent.formParent.stopWalker();
                            MessageBox.Show("Load Map Failed (not a perfect square), need manual axis information.\n\nContact BioMagus with map number or input information in WorldMap.dat");
                            return;
                        }
                        axisx = axisy = SQRTRootAsInt;
                    }
                    MakeMainMap(axisx, axisy);
                    mainMap = myDAMap.GetMakeDAMapChar(MainParent.pathDA + "lod" + path[i].ToString() + ".map", (ushort)axisx, (ushort)axisy);
                    if(mainMap == null) {
                        MainParent.formParent.stopWalker();
                        MessageBox.Show("GetMakeDAMapChar failed: Path Attempted: " + MainParent.pathDA + "lod" + path[i].ToString() + ".map" + " - Axis: " + axisx.ToString() + "," + axisy.ToString());
                        return;
                    }
                } //End of Loading Map

                if(exitLoc != null) {
                    for(int j = 0; j < MaxY; j++) {
                        for(int c = 0; c < MaxX; c++) {
                            if(mainMap[c, j] == (char)0) mainMap[c, j] = 'C';
                        }
                    }
                    for(int j = 0; j < exitLoc.Length; j = j + 2) {
                        mainMap[exitLoc[j], exitLoc[j + 1]] = (char)0;
                    }

                    if(path[i] == 452) mainMap[23, 0] = 'W';
                    if(path[i] == 453) mainMap[23, 0] = 'W';
                    if(path[i] == 10265) mainMap[53, 13] = 'W';
                    if(path[i] == 6228) mainMap[64, 120] = 'W';
                    if(path[i] == 3052) {
                        if(exitLoc[0] == 33 || exitLoc[0] == 11 || exitLoc[0] == 28) {
                            mainMap[24, 25] = 'W';
                            mainMap[25, 25] = 'W';
                            mainMap[26, 25] = 'W';
                            mainMap[27, 25] = 'W';
                        }
                        if(exitLoc[0] == 24 || exitLoc[0] == 11 || exitLoc[0] == 28) {
                            mainMap[33, 25] = 'W';
                            mainMap[34, 25] = 'W';
                            mainMap[35, 25] = 'W';
                            mainMap[36, 25] = 'W';
                        }
                    }
                    if(knownMap) destinationMap = previousMap;
                    else if(lastRun) destinationMap = -1;
                    else destinationMap = path[i + 1];
                    if(!(exitLoc.Length == 2 && X == exitLoc[0] && Y == exitLoc[1])) if(!StartSearch()) { MainParent.formParent.stopWalker(); return; }
                }

                if(!lastRun) mouseLoc = MainParent.mapNodes[path[i]].getMouseLoc(path[i + 1]);
                else mouseLoc = MainParent.mapNodes[path[i]].getMouseLoc(-1);

                if(mouseLoc != null && mouseLoc.Length > 0) {
                    for(int j = 0; j < mouseLoc.Length; j++) {
                        if(mouseLoc[j] == -1) {
                            Thread.Sleep(1400);
                            MainParent.MainSpecial.SendKeyPM(Keys.Space, DarkageshWnd, DAMacTypesLib.DAMacKeyOps.SK_REAL);
                        } else {
                            Thread.Sleep(1000);
                            DAMacTypesLib.MacInfo newParams = new DAMacTypesLib.MacInfo(DarkageshWnd, 0);
                            MainParent.MainSpecial.ClickDAMouse(newParams, (ushort)mouseLoc[j], (ushort)mouseLoc[j + 1], DAMacTypesLib.DAMacOps.CM_DBLCLK | DAMacTypesLib.DAMacOps.CM_RESTOREPOS);
                            j++;
                        }
                    }
                    int counter = 0;
                    while(MapNum != destinationMap && counter < 30 && destinationMap != -1 && MapNum != 6525) {
                        UpdateValues();
                        Thread.Sleep(250);
                        counter++;
                    }
                    if(MapNum == 378) MainParent.formParent.checkBox_louresaite.Checked = false;
                    if(MapNum == 6525) {
                        MainParent.MainSpecial.SendKeyPM(Keys.D1, Keys.ShiftKey, DarkageshWnd, DAMacTypesLib.DAMacKeyOps.SK_REAL);
                        Thread.Sleep(85);
                        MainParent.MainSpecial.SendTextMsgPM("Welcome Aislings", DarkageshWnd);
                        MainParent.MainSpecial.SendKeyPM(Keys.Enter, DarkageshWnd, DAMacTypesLib.DAMacKeyOps.SK_REAL);
                    }
                }
                Thread.Sleep(25);
                previousMap = path[i];
                if(knownMap) {
                    path[i] = temp;
                    knownMap = false;
                }
            }
            MainParent.formParent.stopWalker();
        }

        public bool StartSearch() {
            Running = true;
            memory = pReader.ReadProcessMemory((IntPtr)MapNumAddress, new UIntPtr(2));

            if(memory != null) MapNumStart = (memory[0] + 256 * memory[1]);
            else return false;

            Thread.Sleep(100);

            completeDone = false;
            doorFail = false;
            UpdateValues();
            while(Running) {
                byte CatchExceptions = 10;
                try {
                    FindAndMoveToClosest();
                    if(doorFail) {
                        doorFail = false;
                        return true;
                    }
                    Thread.Sleep(50);
                    UpdateValues();

                    if(MapNum == destinationMap) completeDone = true;

                    //This was the old GetPixel (Which returned BGR Format I think.  Converting to ARGB Format but keeping incase of error
                    //if(MapNum == destinationMap || MainParent.MainSpecial.GetPixelColor(259, 444, DarkageshWnd) == 0x00ad8229 || MainParent.MainSpecial.GetPixelColor(259, 444, DarkageshWnd) == 0x00fff7ef) Running = false;
                    if(MapNum == destinationMap || MainParent.MainSpecial.GetPixelColor(259, 444, DarkageshWnd) == 0xff2982ad || MainParent.MainSpecial.GetPixelColor(259, 444, DarkageshWnd) == 0xffeff7ff) Running = false;
                    else if(MapNum == 3016 || MapNum == 3058) {
                        MainParent.MainSpecial.SendKeyPM(Keys.Space, DarkageshWnd, DAMacTypesLib.DAMacKeyOps.SK_REAL);
                        Thread.Sleep(1400);
                    } else if(completeDone) Running = false;

                    CatchExceptions = 10;
                } catch(Exception) { Thread.Sleep(250); if(--CatchExceptions == 0) Running = false; }
            }
            return true;
        }

        public bool StartProcessCheck() {
            System.Diagnostics.Process[] myProcesses = System.Diagnostics.Process.GetProcessesByName("Darkages");

            if(myProcesses.Length == 0) {
                new Thread(MainParent.NotificationWindow).Start("No DarkaAges Process found!");
                return false;
            }

            pReader.OpenProcess((uint)myProcesses[0].Id);

            DarkageshWnd = myProcesses[0].MainWindowHandle;

            //0x6FCF00 contains the value of the X/Y/Coord + Offsets - Added From here to return
            memory = pReader.ReadProcessMemory((IntPtr)InfoBasePtr, new UIntPtr(4));
            int refTemp = (memory[0] + 256 * memory[1] + 256 * 256 * memory[2] + 256 * 256 * 256 * memory[3]);

            XAddress = refTemp + XAddressOff;
            YAddress = refTemp + YAddressOff;
            MapNumAddress = refTemp + MapNumAddressOff;

            return true;
        }

        private void FindAndMoveToClosest() {
            bool FoundEmptySpot = false;
            char[,] mainMapCheck = new char[MaxX, MaxY];
            Queue SearchQue = new Queue();
            UpdateValues();
            int CurX = X;
            int CurY = Y;

            mainMapCheck[CurX, CurY] = 'S';
            while(!FoundEmptySpot) {
                //Check Left
                if(CurX > 0 && mainMap[CurX - 1, CurY] == 0) {
                    mainMapCheck[CurX - 1, CurY] = 'R';
                    CurX--;
                    destinX = CurX;
                    destinY = CurY;
                    FoundEmptySpot = true;
                } else {
                    if(CurX > 0 && mainMap[CurX - 1, CurY] == 'C' && mainMapCheck[CurX - 1, CurY] == 0) {
                        mainMapCheck[CurX - 1, CurY] = 'R';
                        SearchQue.Enqueue(new int[] { CurX - 1, CurY });
                    }

                    //Check Up
                    if(CurY > 0 && mainMap[CurX, CurY - 1] == 0) {
                        mainMapCheck[CurX, CurY - 1] = 'D';
                        CurY--;
                        destinX = CurX;
                        destinY = CurY;
                        FoundEmptySpot = true;
                    } else {
                        if(CurY > 0 && mainMap[CurX, CurY - 1] == 'C' && mainMapCheck[CurX, CurY - 1] == 0) {
                            mainMapCheck[CurX, CurY - 1] = 'D';
                            SearchQue.Enqueue(new int[] { CurX, CurY - 1 });
                        }

                        //Check Right
                        if(CurX < MaxX - 1 && mainMap[CurX + 1, CurY] == 0) {
                            mainMapCheck[CurX + 1, CurY] = 'L';
                            CurX++;
                            destinX = CurX;
                            destinY = CurY;
                            FoundEmptySpot = true;
                        } else {
                            if(CurX < MaxX - 1 && mainMap[CurX + 1, CurY] == 'C' && mainMapCheck[CurX + 1, CurY] == 0) {
                                mainMapCheck[CurX + 1, CurY] = 'L';
                                SearchQue.Enqueue(new int[] { CurX + 1, CurY });
                            }

                            //Check Down
                            if(CurY < MaxY - 1 && mainMap[CurX, CurY + 1] == 0) {
                                mainMapCheck[CurX, CurY + 1] = 'U';
                                CurY++;
                                destinX = CurX;
                                destinY = CurY;
                                FoundEmptySpot = true;
                            } else {
                                if(CurY < MaxY - 1 && mainMap[CurX, CurY + 1] == 'C' && mainMapCheck[CurX, CurY + 1] == 0) {
                                    mainMapCheck[CurX, CurY + 1] = 'U';
                                    SearchQue.Enqueue(new int[] { CurX, CurY + 1 });
                                }

                                //Check if anything else to check & Update CurX and CurY
                                if(SearchQue.Count == 0) {
                                    ClearSearched();
                                    return;
                                } else {
                                    int[] TempCoords = new int[2];
                                    TempCoords = (int[])SearchQue.Dequeue();
                                    CurX = TempCoords[0];
                                    CurY = TempCoords[1];
                                }
                            }
                        }
                    }
                }
            }
            MoveTo(CurX, CurY, mainMapCheck);
        }

        private void MoveTo(int NewX, int NewY, char[,] BPath) {
            char[] Path = new char[(MaxX * MaxY) / 2 + (MaxX + MaxY) / 2];
            int loc = 0;
            int XCur = NewX;
            int YCur = NewY;
            int counter = 1;

            //Build Path Array from BPath
            while(BPath[XCur, YCur] != 'S') {
                if(BPath[XCur, YCur] == 'R') {
                    Path[loc++] = 'L';
                    XCur++;
                } else if(BPath[XCur, YCur] == 'D') {
                    Path[loc++] = 'U';
                    YCur++;
                } else if(BPath[XCur, YCur] == 'L') {
                    Path[loc++] = 'R';
                    XCur--;
                } else if(BPath[XCur, YCur] == 'U') {
                    Path[loc++] = 'D';
                    YCur--;
                }
            }

            //Process the 'C' Moves
            while(--loc > 0) {
                UpdateValues();
                counter = 1;
                XCur = X;
                YCur = Y;

                if(Path[loc] == 'L') {
                    if(MapNum == destinationMap) return;
                    while(XCur == X) {
                        if(++counter > WallChecks) {
                            if(mainMap[X - 1, Y] != 'W') mainMap[X - 1, Y] = 'A';
                            return;
                        }
                        MoveLeft();
                        Thread.Sleep(delay);
                        UpdateValues();
                    }
                    if(MapNumStart != MapNum) {
                        if(mainMap[XCur - 1, YCur] != 'W') mainMap[XCur - 1, YCur] = 'A';
                        if(!ThroughDoorMoving("Left")) {
                            doorFail = true;
                            return;
                        }
                    }
                } else if(Path[loc] == 'U') {
                    if(MapNum == destinationMap) return;
                    while(YCur == Y) {
                        if(++counter > WallChecks) {
                            if(mainMap[X, Y - 1] != 'W') mainMap[X, Y - 1] = 'A';
                            return;
                        }
                        MoveUp();
                        Thread.Sleep(delay);
                        UpdateValues();
                    }
                    if(MapNumStart != MapNum) {
                        if(mainMap[XCur, YCur - 1] != 'W') mainMap[XCur, YCur - 1] = 'A';
                        if(!ThroughDoorMoving("Up")) {
                            doorFail = true;
                            return;
                        }
                    }
                } else if(Path[loc] == 'R') {
                    if(MapNum == destinationMap) return;
                    while(XCur == X) {
                        if(++counter > WallChecks) {
                            if(mainMap[X + 1, Y] != 'W') mainMap[X + 1, Y] = 'A';
                            return;
                        }
                        MoveRight();
                        Thread.Sleep(delay);
                        UpdateValues();
                    }
                    if(MapNumStart != MapNum) {
                        if(mainMap[XCur + 1, YCur] != 'W') mainMap[XCur + 1, YCur] = 'A';
                        if(!ThroughDoorMoving("Right")) {
                            doorFail = true;
                            return;
                        }
                    }
                } else if(Path[loc] == 'D') {
                    if(MapNum == destinationMap) return;
                    while(YCur == Y) {
                        if(++counter > WallChecks) {
                            if(mainMap[X, Y + 1] != 'W') mainMap[X, Y + 1] = 'A';
                            return;
                        }
                        MoveDown();
                        Thread.Sleep(delay);
                        UpdateValues();
                    }
                    if(MapNumStart != MapNum) {
                        if(mainMap[XCur, YCur + 1] != 'W') mainMap[XCur, YCur + 1] = 'A';
                        if(!ThroughDoorMoving("Down")) {
                            doorFail = true;
                            return;
                        }
                    }
                }
            }

            // Process's the Last Move
            counter = 1;
            XCur = X;
            YCur = Y;

            if(Path[loc] == 'L') {
                if(MapNum == destinationMap) {
                    completeDone = true;
                    return;
                }
                while(XCur == X) {
                    if(++counter > WallChecks) {
                        if(mainMap[X - 1, Y] != 'W') mainMap[X - 1, Y] = 'A';
                        break;
                    }
                    MoveLeft();
                    Thread.Sleep(delay);
                    UpdateValues();
                }
            } else if(Path[loc] == 'U') {
                if(MapNum == destinationMap) {
                    completeDone = true;
                    return;
                }
                while(YCur == Y) {
                    if(++counter > WallChecks) {
                        if(mainMap[X, Y - 1] != 'W') mainMap[X, Y - 1] = 'A';
                        break;
                    }
                    MoveUp();
                    Thread.Sleep(delay);
                    UpdateValues();
                }
            } else if(Path[loc] == 'R') {
                if(MapNum == destinationMap) {
                    completeDone = true;
                    return;
                }
                while(XCur == X) {
                    if(++counter > WallChecks) {
                        if(mainMap[X + 1, Y] != 'W') mainMap[X + 1, Y] = 'A';
                        break;
                    }
                    MoveRight();
                    Thread.Sleep(delay);
                    UpdateValues();
                }
            } else if(Path[loc] == 'D') {
                if(MapNum == destinationMap) {
                    completeDone = true;
                    return;
                }
                while(YCur == Y) {
                    if(++counter > WallChecks) {
                        if(mainMap[X, Y + 1] != 'W') mainMap[X, Y + 1] = 'A';
                        break;
                    }
                    MoveDown();
                    Thread.Sleep(delay);
                    UpdateValues();
                }
            }
            completeDone = true;
        }

        private bool ThroughDoorMoving(string direction) {
            int counter = 0;

            while(MapNumStart != MapNum && MapNum != destinationMap) {
                if(counter >= 3 && counter < 5) {
                    if(direction == "Left") MoveDown();
                    else if(direction == "Up") MoveLeft();
                    else if(direction == "Right") MoveUp();
                    else if(direction == "Down") MoveRight();
                    Thread.Sleep(1050);
                    UpdateValues();
                } else if(counter >= 5 && counter < 9) {
                    if(direction == "Left") MoveUp();
                    else if(direction == "Up") MoveRight();
                    else if(direction == "Right") MoveDown();
                    else if(direction == "Down") MoveLeft();
                    Thread.Sleep(1050);
                    UpdateValues();
                } else if(counter >= 9) {
                    return false;
                } else {
                    if(direction == "Left") MoveRight();
                    else if(direction == "Up") MoveDown();
                    else if(direction == "Right") MoveLeft();
                    else if(direction == "Down") MoveUp();
                    Thread.Sleep(1050);
                    UpdateValues();
                }
                counter++;
            }
            return true;
        }

        // KeyDown	lParam = (0/4)1(50/4B/48/4D)0001   (4 if Continues, 0 for first)
        // KeyUp	lParam = C1(50/4B/48/4D)0001
        private void MoveLeft() {
            if(PrevDirection == "Left") {
                PostMessage(DarkageshWnd, 0x0100, (int)Keys.Left, 0x014B0001);
                PostMessage(DarkageshWnd, 0x0101, (int)Keys.Left, 0xC14B0001);
            } else {
                PostMessage(DarkageshWnd, 0x0100, (int)Keys.Left, 0x014B0001);
                PostMessage(DarkageshWnd, 0x0101, (int)Keys.Left, 0xC14B0001);
                PostMessage(DarkageshWnd, 0x0100, (int)Keys.Left, 0x014B0001);
                PostMessage(DarkageshWnd, 0x0101, (int)Keys.Left, 0xC14B0001);
                PrevDirection = "Left";
            }
        }
        private void MoveUp() {
            if(PrevDirection == "Up") {
                PostMessage(DarkageshWnd, 0x0100, (int)Keys.Up, 0x01480001);
                PostMessage(DarkageshWnd, 0x0101, (int)Keys.Up, 0xC1480001);
            } else {
                PostMessage(DarkageshWnd, 0x0100, (int)Keys.Up, 0x01480001);
                PostMessage(DarkageshWnd, 0x0101, (int)Keys.Up, 0xC1480001);
                PostMessage(DarkageshWnd, 0x0100, (int)Keys.Up, 0x01480001);
                PostMessage(DarkageshWnd, 0x0101, (int)Keys.Up, 0xC1480001);
                PrevDirection = "Up";
            }
        }
        private void MoveRight() {
            if(PrevDirection == "Right") {
                PostMessage(DarkageshWnd, 0x0100, (int)Keys.Right, 0x014D0001);
                PostMessage(DarkageshWnd, 0x0101, (int)Keys.Right, 0xC14D0001);
            } else {
                PostMessage(DarkageshWnd, 0x0100, (int)Keys.Right, 0x014D0001);
                PostMessage(DarkageshWnd, 0x0101, (int)Keys.Right, 0xC14D0001);
                PostMessage(DarkageshWnd, 0x0100, (int)Keys.Right, 0x014D0001);
                PostMessage(DarkageshWnd, 0x0101, (int)Keys.Right, 0xC14D0001);
                PrevDirection = "Right";
            }
        }
        private void MoveDown() {
            if(PrevDirection == "Down") {
                PostMessage(DarkageshWnd, 0x0100, (int)Keys.Down, 0x01500001);
                PostMessage(DarkageshWnd, 0x0101, (int)Keys.Down, 0xC1500001);
            } else {
                PostMessage(DarkageshWnd, 0x0100, (int)Keys.Down, 0x01500001);
                PostMessage(DarkageshWnd, 0x0101, (int)Keys.Down, 0xC1500001);
                PostMessage(DarkageshWnd, 0x0100, (int)Keys.Down, 0x01500001);
                PostMessage(DarkageshWnd, 0x0101, (int)Keys.Down, 0xC1500001);
                PrevDirection = "Down";
            }
        }

        private void MakeMainMap(int GivenX, int GivenY) {
            MaxX = GivenX;
            MaxY = GivenY;

            mainMap = new char[MaxX, MaxY];
        }

        public void UpdateValues() {
            if((memory = pReader.ReadProcessMemory((IntPtr)XAddress, (UIntPtr)1)) == null) { Running = false; return; }
            X = (memory[0]);
            if((memory = pReader.ReadProcessMemory((IntPtr)YAddress, (UIntPtr)1)) == null) { Running = false; return; }
            Y = (memory[0]);
            if((memory = pReader.ReadProcessMemory((IntPtr)MapNumAddress, (UIntPtr)2)) == null) { Running = false; return; }
            MapNum = (memory[0] + 256 * memory[1]);
        }

        public void LoadSavedMap(string name) {
            string[] SavedFile;

            try {
                using(StreamReader OpenFile = File.OpenText(name)) SavedFile = OpenFile.ReadToEnd().Split('\n');
                if(SavedFile.Length != 4) {
                    new Thread(MainParent.NotificationWindow).Start("Coudln't Open File - Wasn't a DASearcher Saved File");
                    return;
                }
            } catch(Exception e) {
                new Thread(MainParent.NotificationWindow).Start("Coudln't Open File" + e.Message);
                return;
            }

            int c = 0;
            int i = 0;

            try { MakeMainMap(Convert.ToInt16(SavedFile[0]), Convert.ToInt16(SavedFile[1])); } catch(Exception e) {
                new Thread(MainParent.NotificationWindow).Start("Coudln't Open Map File: " + e.Message);
                return;
            }

            for(int j = 0; j < SavedFile[3].Length; j++) {
                if(c >= MaxX || i >= MaxY) {
                    new Thread(MainParent.NotificationWindow).Start("Files in Wrong Format");
                    return;
                }
                mainMap[c++, i] = SavedFile[3][j];
                if(c == MaxX) {
                    i++;
                    c = 0;
                }
            }
        }

        public void ClearMap() { mainMap = new char[MaxX, MaxY]; }

        public void ClearSearched() {
            for(int i = 0; i < MaxY; i++) {
                for(int c = 0; c < MaxX; c++) {
                    if(mainMap[c, i] == 'C' || mainMap[c, i] == 'A') mainMap[c, i] = (char)0;
                }
            }
        }
    }
}