using System;
using System.Runtime.InteropServices;
using System.Threading;
using System.Windows.Forms;

namespace DAWalkerWorldMapEditor {
    public partial class MouseLocator : Form {
        /*BOOL ScreenToClient(
            HWND hWnd,
            LPPOINT lpPoint
        );*/
        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        private static extern bool ScreenToClient(IntPtr hWnd, ref System.Drawing.Point lpPoint);
        ///     HWND GetForegroundWindow(VOID);
        /*HWND GetForegroundWindow(VOID);*/
        [DllImport("user32.dll")]
        private static extern IntPtr GetForegroundWindow();
        /*BOOL RegisterHotKey(
            HWND hWnd,
            int id,
            UINT fsModifiers,
            UINT vk
        );*/
        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        private static extern bool RegisterHotKey(IntPtr hWnd, int id, uint fsModifiers, uint vk);
        /*BOOL UnregisterHotKey(
            HWND hWnd,
            int id
        );*/
        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        private static extern bool UnregisterHotKey(IntPtr hWnd, int id);


        public DAWalkerWorldMapEditorForm MainF;
        private bool Running = true;
        private Thread DisplayCoordsThread;
        private const byte MOD_CONTROL = 0x0002;

        public MouseLocator() {
            InitializeComponent();
            RegisterHotKey(this.Handle, 101, MOD_CONTROL, (uint)Keys.Space);
            (DisplayCoordsThread = new Thread(new System.Threading.ThreadStart(DisplayCoords))).Start();
        }

        private const ushort WM_HOTKEY = 0x0312;
        protected override void WndProc(ref Message m) {
            base.WndProc(ref m);
            if(m.Msg == WM_HOTKEY) {
                System.Drawing.Point MouseCoords = Cursor.Position;
                tbScreenCoord.Text = MouseCoords.X.ToString() + "," + MouseCoords.Y.ToString();
                ScreenToClient(GetForegroundWindow(), ref MouseCoords);
                tbWindowCoord.Text = MouseCoords.X.ToString() + "," + MouseCoords.Y.ToString();
            }
        }

        public void DisplayCoords() {
            System.Drawing.Point MouseCoords;
            while(Running) {
                MouseCoords = Cursor.Position;
                lblCoordsScreen.Text = MouseCoords.X.ToString() + "," + MouseCoords.Y.ToString();
                ScreenToClient(GetForegroundWindow(), ref MouseCoords);
                lblCoordsActive.Text = MouseCoords.X.ToString() + "," + MouseCoords.Y.ToString();

                Application.DoEvents();
            }
        }

        private void MouseLocator_FormClosing(object sender, FormClosingEventArgs e) {
            Running = false;
            Thread.Sleep(5);
            if(DisplayCoordsThread.IsAlive) DisplayCoordsThread.Abort();
            MainF.btnMouseCoords.Enabled = true;

            UnregisterHotKey(this.Handle, 101);
        }
    }
}