using System;
using System.Threading;
using System.Windows.Forms;

namespace DAWalkerWorldMapEditor {
    static class ProgStart {
        [STAThread]
        static void Main() {
            if(System.Diagnostics.Process.GetProcessesByName("DAWalkerWorldMapEditor").Length == 2) return;
            AppDomain.CurrentDomain.UnhandledException += new UnhandledExceptionEventHandler(MyUnhandledEx);
            Application.ThreadException += new System.Threading.ThreadExceptionEventHandler(MyThreadingEx);

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new DAWalkerWorldMapEditorForm());
        }

        static void MyUnhandledEx(object sender, UnhandledExceptionEventArgs args) {
            using(System.IO.StreamWriter sw = new System.IO.StreamWriter("CrashLogUnhandledEx (DAWalkerWorldMapEditor " + Application.ProductVersion + ") " + DateTime.Now.ToString("u", System.Globalization.CultureInfo.InvariantCulture).TrimEnd('Z').Replace(":", "-") + ".txt", true)) sw.WriteLine(((Exception)args.ExceptionObject).ToString());
            Environment.Exit(0);
        }

        static void MyThreadingEx(object sender, ThreadExceptionEventArgs args) {
            using(System.IO.StreamWriter sw = new System.IO.StreamWriter("CrashLogThreadingEx (DAWalkerWorldMapEditor " + Application.ProductVersion + ") " + DateTime.Now.ToString("u", System.Globalization.CultureInfo.InvariantCulture).TrimEnd('Z').Replace(":", "-") + ".txt", true)) sw.WriteLine(args.Exception.ToString());
            Environment.Exit(0);
        }
    }
}